VERSION 5.00
Begin VB.Form MainForm 
   Caption         =   "S&K PC Collection MIDI Tool"
   ClientHeight    =   3030
   ClientLeft      =   225
   ClientTop       =   855
   ClientWidth     =   4560
   LinkTopic       =   "Form1"
   ScaleHeight     =   202
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   304
   StartUpPosition =   3  'Windows-Standard
   Begin VB.OptionButton FormatOption 
      Caption         =   "&MID"
      Height          =   255
      Index           =   1
      Left            =   3600
      TabIndex        =   7
      Top             =   360
      Width           =   735
   End
   Begin VB.OptionButton FormatOption 
      Caption         =   "&BIN"
      Height          =   255
      Index           =   0
      Left            =   2760
      TabIndex        =   6
      Top             =   360
      Width           =   735
   End
   Begin VB.CommandButton DumpRplButton 
      Caption         =   "&Reset Track"
      Height          =   495
      Index           =   2
      Left            =   2760
      TabIndex        =   4
      Top             =   2280
      Width           =   1215
   End
   Begin VB.CommandButton DumpRplButton 
      Caption         =   "&Insert File"
      Height          =   495
      Index           =   1
      Left            =   2760
      TabIndex        =   3
      Top             =   1560
      Width           =   1215
   End
   Begin VB.CommandButton DumpRplButton 
      Caption         =   "&Dump File"
      Height          =   495
      Index           =   0
      Left            =   2760
      TabIndex        =   2
      Top             =   840
      Width           =   1215
   End
   Begin VB.ListBox SongList 
      Height          =   2400
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2175
   End
   Begin VB.Label FormatLabel 
      Caption         =   "File Format:"
      Height          =   255
      Left            =   2520
      TabIndex        =   5
      Top             =   120
      Width           =   975
   End
   Begin VB.Label StatusLabel 
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   2640
      Width           =   4215
   End
   Begin VB.Menu MenuFile 
      Caption         =   "&File"
      Begin VB.Menu MenuFileEntry 
         Caption         =   "&Open DLL"
         Index           =   0
         Shortcut        =   ^O
      End
      Begin VB.Menu MenuFileEntry 
         Caption         =   "&Save DLL"
         Index           =   1
         Shortcut        =   ^S
      End
      Begin VB.Menu MenuFileEntry 
         Caption         =   "-"
         Index           =   2
      End
      Begin VB.Menu MenuFileEntry 
         Caption         =   "&Quit"
         Index           =   3
         Shortcut        =   {F4}
      End
   End
   Begin VB.Menu MenuDmpRpl 
      Caption         =   "Dump/Replace &all"
      Begin VB.Menu MenuDmpRplEntry 
         Caption         =   "Dump all to &BIN"
         Index           =   0
      End
      Begin VB.Menu MenuDmpRplEntry 
         Caption         =   "Dump all to &MID"
         Index           =   1
      End
      Begin VB.Menu MenuDmpRplEntry 
         Caption         =   "&Replace all with BIN"
         Index           =   2
      End
      Begin VB.Menu MenuDmpRplEntry 
         Caption         =   "R&eplace all with MID"
         Index           =   3
      End
      Begin VB.Menu MenuDmpRplEntry 
         Caption         =   "-"
         Index           =   4
      End
      Begin VB.Menu MenuDmpRplEntry 
         Caption         =   "Dump &Sys-Ex Init-Data"
         Index           =   5
      End
      Begin VB.Menu MenuDmpRplEntry 
         Caption         =   "Insert Sys-E&x Init-Data"
         Index           =   6
      End
   End
   Begin VB.Menu MenuExtras 
      Caption         =   "E&xtras"
      Begin VB.Menu MenuExtrasEntry 
         Caption         =   "Convert &BIN -> MID"
         Index           =   0
      End
      Begin VB.Menu MenuExtrasEntry 
         Caption         =   "Convert &MID -> BIN"
         Index           =   1
      End
      Begin VB.Menu MenuExtrasEntry 
         Caption         =   "&Decompress BIN"
         Index           =   2
      End
      Begin VB.Menu MenuExtrasEntry 
         Caption         =   "&Compress BIN"
         Index           =   3
      End
   End
   Begin VB.Menu MenuOption 
      Caption         =   "&Options"
      Begin VB.Menu MenuOptionEntry 
         Caption         =   "&Export -> MID"
         Index           =   0
         Begin VB.Menu MenuOptExEntry 
            Caption         =   "Loop &Ctrl 111"
            Index           =   0
         End
         Begin VB.Menu MenuOptExEntry 
            Caption         =   "&Loops: 0 ..."
            Index           =   1
         End
      End
      Begin VB.Menu MenuOptionEntry 
         Caption         =   "&Import -> BIN"
         Index           =   1
         Begin VB.Menu MenuOptImEntry 
            Caption         =   "Fix &Loop Points"
            Checked         =   -1  'True
            Index           =   0
         End
         Begin VB.Menu MenuOptImEntry 
            Caption         =   "&Standardize MIDIs"
            Index           =   1
         End
         Begin VB.Menu MenuOptImEntry 
            Caption         =   "Standardize &Options"
            Index           =   2
            Begin VB.Menu MenuStdOptEntry 
               Caption         =   "XG &Drums"
               Index           =   0
            End
            Begin VB.Menu MenuStdOptEntry 
               Caption         =   "&No Uncommon Ctrls"
               Index           =   1
            End
            Begin VB.Menu MenuStdOptEntry 
               Caption         =   "&Controller Options ..."
               Index           =   2
            End
            Begin VB.Menu MenuStdOptEntry 
               Caption         =   "No &Bank Select on Ch 10"
               Index           =   3
            End
         End
      End
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

' TODO: Import Options
'       -> single selection of additional Standardize-Controllers

Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" _
    (ByRef hpvDest As Any, ByRef hpvSource As Any, ByVal cbCopy As Long)
Private Declare Sub MoveMemory Lib "kernel32" Alias "RtlMoveMemory" _
    (ByRef hpvDest As Any, ByRef hpvSource As Any, ByVal cbCopy As Long)
Private Declare Sub FillMemory Lib "kernel32" Alias "RtlFillMemory" _
    (ByRef hpvDest As Any, ByVal cbCopy As Long, ByVal Char As Byte)

' 0-55 - FM, 56-111 - GM
Private Const SONG_NAMES As String = _
    "S3 Title|AIZ 1|AIZ 2|HCZ 1|HCZ 2|MGZ 1|MGZ 2|CNZ 1|" & _
    "CNZ 2|FBZ 1|FBZ 2|ICZ 1|ICZ 2|LBZ 1|LBZ 2|MHZ 1|" & _
    "MHZ 2|SZ 1|SZ 2|LRZ 1|LRZ 2/HPZ|SSZ|DEZ 1|DEZ 2|" & _
    "Act 1 Boss|Act 2 Boss|DDZ|Glowing Sphere|Special|Slot|Gumball|S3 Knuckles|" & _
    "2P ALZ|2P BPZ|2P DPZ|2P CGZ|2P EMZ|Game Over|Results|Act Clear|" & _
    "S3 Life|Emerald|S3 Invinc|2P Menu|Unused|Options|Final Boss|Timer|" & _
    "S3 Clear|S3 Credits|S3K Knuckles|S3K Title|S3K Life|S3K Invinc|" & _
    "S3K Clear|S3K Credits"
Private Const SONG_NAMES_LONG As String = _
    "Sonic 3: Title Screen|Angel Island Zone 1|Angel Island Zone 2|Hydrocity Zone 1|" & _
    "Hydrocity Zone 2|Marble Garden Zone 1|Marble Garden Zone 2|Carnival Night Zone 1|" & _
    "Carnival Night Zone 2|Flying Battery Zone 1|Flying Battery Zone 2|Ice Cap Zone 1|" & _
    "Ice Cap Zone 2|Launch Base Zone 1|Launch Base Zone 2|Mushroom Hill Zone 1|" & _
    "Mushroom Hill Zone 2|Sandopolis Zone 1|Sandopolis Zone 2|Lava Reef Zone 1|" & _
    "Lava Reef Zone 2/Hidden Palace Zone|Sky Sanctuary Zone|Death Egg Zone 1|Death Egg Zone 2|" & _
    "Act 1 Boss|Act 2 Boss|Doomsday Zone|Glowing Sphere Machine|" & _
    "Special Stage|Slot Machine|Gumball Machine|Sonic 3: Knuckles|" & _
    "Competition: Azure Lake Zone|Competition: Baloon Park Zone|Competition: Desert Palace Zone|Competition: Chrome Gadget Zone|" & _
    "Competition: Endless Mine Zone|Game Over|Competition: Results|Act Clear|" & _
    "Sonic 3: Extra Life|Got Chaos Emerald|Sonic 3: Invincibility|Competition: Menu|" & _
    "Unused Song|Options Screen|Final Boss Theme|Drowning Timer|" & _
    "Sonic 3: Game Clear|Sonic 3: Credits|Sonic 3 & Knuckles: Knuckles|Sonic 3 & Knuckles: Title Screen|" & _
    "Sonic 3 & Knuckles: Extra Life|Sonic 3 & Knuckles: Invincibility|" & _
    "Sonic 3 & Knuckles: Game Clear|Sonic 3 & Knuckles: Credits"
Private SONG_NAME() As String
Private SONG_NAME_LONG() As String

Private Const FILTER_BIN As String = "S&K PC Binary MIDIs (*.bin)|*.bin"
Private Const FILTER_MID As String = "Standard MIDI Files (*.mid)|*.mid"
Private Const FILTER_CMP As String = "S&K PC Compressed MIDIs (*.bin; *.cmp)|*.cmp; *.bin"
Private Const FILTER_SYX As String = "SysEx Data File (*.syx)|*.syx"

Private Type MIDI_TOC
    DataPos As Long
    DataLen As Long
    Dummy1 As Long
    Dummy2 As Long
End Type
Private Type MIDI_SWAP
    DataPos As Long
    DataLen As Long
    Data() As Byte
    Changed As Boolean
End Type

Private Type FORM_CTRL_DATA
    Left As Integer
    Top As Integer
    Width As Integer
    Height As Integer
    Right As Integer
    Bottom As Integer
    SpcX As Integer
    SpcY As Integer
    RelX As Single
    RelY As Single
    RelWidth As Single
    RelHeight As Single
End Type
Private Const FRMCTRL_FORM = &H0
Private Const FRMCTRL_SONGLIST = &H1
Private Const FRMCTRL_STAT_LBL = &H2
Private Const FRMCTRL_BUTTONS = &H3
Private Const FRMCTRL_FORMAT = &H6

Private NameMode As Boolean ' I just want to play a little

Private MidCount As Integer
Private MidTOC() As MIDI_TOC
Private MidSwap() As MIDI_SWAP

Private DLLName As String
Private DLLSize As Long
Private DLLData() As Byte

Private FormCtrls(&H0 To &HF) As FORM_CTRL_DATA

Private Sub Form_Load()

    Dim CurSong As Byte
    
    ReDim MidSwap(&H0 To &H6F)
    
    With FormCtrls(FRMCTRL_FORM)
        .Width = Me.Width
        .Height = Me.Height
    End With
    Call SaveCtrlSize(FormCtrls(FRMCTRL_SONGLIST), SongList)
    Call SaveCtrlSize(FormCtrls(FRMCTRL_STAT_LBL), StatusLabel)
    For CurSong = 0 To 2
        Call SaveCtrlSize(FormCtrls(FRMCTRL_BUTTONS + CurSong), _
                            DumpRplButton(CurSong))
    Next CurSong
    Call SaveCtrlSize(FormCtrls(FRMCTRL_FORMAT + &H0), FormatLabel)
    For CurSong = 0 To 1
        Call SaveCtrlSize(FormCtrls(FRMCTRL_FORMAT + &H1 + CurSong), _
                            FormatOption(CurSong))
    Next CurSong
    
    SONG_NAME() = Split(SONG_NAMES, "|")
    SONG_NAME_LONG() = Split(SONG_NAMES_LONG, "|")
    
    CnvOpts.LoopCnt = 2
    StdzOpts.Ctrls(&H0) = True  ' Bank Select MSB
    StdzOpts.Ctrls(&H20) = True ' Bank Select LSB
    StdzOpts.Ctrls(&H1) = True  ' Modulation
    StdzOpts.Ctrls(&H7) = True  ' Main Volume
    StdzOpts.Ctrls(&HA) = True  ' Panorama
    StdzOpts.Ctrls(&HB) = True  ' Expression
    StdzOpts.Ctrls(&H40) = True ' ^
    StdzOpts.Ctrls(&H41) = True ' | Pedals
    StdzOpts.Ctrls(&H42) = True ' |
    StdzOpts.Ctrls(&H43) = True ' v
    StdzOpts.Ctrls(&H5B) = True ' Reverb
    StdzOpts.Ctrls(&H5D) = True ' Chorus
    StdzOpts.Ctrls(&H64) = True ' Registered Parameter
    
    MenuFileEntry(1).Enabled = False
    MenuDmpRpl.Enabled = False
    SongList.Enabled = False
    For CurSong = 0 To 2
        DumpRplButton(CurSong).Enabled = False
    Next CurSong
    FormatLabel.Enabled = False
    For CurSong = 0 To 1
        FormatOption(CurSong).Enabled = False
    Next CurSong
    FormatOption(1).Value = True
    MenuOptImEntry(2).Enabled = MenuOptImEntry(1).Checked
    MenuOptExEntry(1).Caption = "&Loops: " & CStr(CnvOpts.LoopCnt) & " ..."
    
    CnvOpts.LoopCtrl = MenuOptExEntry(0).Checked
    CnvOpts.FixLoops = MenuOptImEntry(0).Checked
    CnvOpts.StdzMidis = MenuOptImEntry(1).Checked
    StdzOpts.XGDrum = MenuStdOptEntry(0).Checked
    StdzOpts.NoUncmnCtrls = MenuStdOptEntry(1).Checked
    StdzOpts.DrumBnkSel = MenuStdOptEntry(3).Checked
    
    NameMode = False
    For CurSong = &H0 To &H6F
        SongList.AddItem GetSongName(CurSong), CurSong
    Next CurSong
    
    StatusLabel.Caption = "Ready."

End Sub

Private Sub SaveCtrlSize(ByRef SaveData As FORM_CTRL_DATA, _
                        ByRef FormCtrl As Control)

    With SaveData
        .Left = FormCtrl.Left
        .Top = FormCtrl.Top
        .Width = FormCtrl.Width
        .Height = FormCtrl.Height
        
        .Right = Me.ScaleWidth - (.Left + .Width)
        .Bottom = Me.ScaleHeight - (.Top + .Height)
        .SpcX = Me.ScaleWidth - .Width
        .SpcY = Me.ScaleHeight - .Height
        .RelX = (.Left + .Width / 2) / Me.ScaleWidth
        .RelY = (.Top + .Height / 2) / Me.ScaleHeight
        .RelWidth = .Width / Me.ScaleWidth
        .RelHeight = .Height / Me.ScaleHeight
    End With

End Sub

Private Function DiscardQuestion(ByVal QstnStr As String) As Boolean

    ' True - discard and continue
    ' False - stop by all means
    
    Dim CurSong As Integer
    Dim ChgQstn As Boolean
    Dim MsgRes As VbMsgBoxResult
    
    ChgQstn = False
    For CurSong = &H0 To MidCount - 1
        If MidSwap(CurSong).Changed Then
            ChgQstn = True
            Exit For
        End If
    Next CurSong
    
    If ChgQstn Then
        MsgRes = MsgBox("You made changes. " & QstnStr, vbQuestion Or vbYesNo)
        If MsgRes = vbNo Then
            DiscardQuestion = False
            Exit Function
        End If
    End If
    
    DiscardQuestion = True

End Function

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)

    If Not DiscardQuestion("Are you sure to quit?" & vbNewLine & _
        "You'll lose them all!") Then
        Cancel = True
    End If

End Sub

Private Sub Form_Resize()

    If Me.WindowState = vbMinimized Then Exit Sub
    
    Dim CurBtn As Byte
    Dim NewMode As Boolean
    
    With FormCtrls(FRMCTRL_FORM)
        If Me.Width < .Width Then
            Me.Width = .Width
        End If
        If Me.Height < .Height Then
            Me.Height = .Height
        End If
    End With
    NewMode = CBool(Me.Width >= 560 * 15)
    If NewMode <> NameMode Then
        ' Yes - I know I've got too much spare time
        NameMode = NewMode
        Call RewriteSongList
    End If
    
    With FormCtrls(FRMCTRL_SONGLIST)
        SongList.Height = Me.ScaleHeight - .SpcY
        SongList.Width = .RelWidth * Me.ScaleWidth
    End With
    With FormCtrls(FRMCTRL_STAT_LBL)
        StatusLabel.Top = Me.ScaleHeight - .Bottom - .Height
        StatusLabel.Width = Me.ScaleWidth - .SpcX
    End With
    
    For CurBtn = 0 To 2
        With FormCtrls(FRMCTRL_BUTTONS + CurBtn)
            DumpRplButton(CurBtn).Left = .RelX * Me.ScaleWidth - .Width / 2
            DumpRplButton(CurBtn).Top = .RelY * Me.ScaleHeight - .Height / 2
        End With
    Next CurBtn
    
    With FormCtrls(FRMCTRL_FORMAT + &H0)
        FormatLabel.Left = .RelX * Me.ScaleWidth - .Width / 2
        FormatLabel.Top = .RelY * Me.ScaleHeight - .Height / 2
    End With
    For CurBtn = 0 To 1
        With FormCtrls(FRMCTRL_FORMAT + &H1 + CurBtn)
            FormatOption(CurBtn).Left = .RelX * Me.ScaleWidth - .Width / 2
            FormatOption(CurBtn).Top = .RelY * Me.ScaleHeight - .Height / 2
        End With
    Next CurBtn

End Sub

Private Sub RewriteSongList()

    Dim CurSong As Byte
    Dim TempStr As String
    
    For CurSong = &H0 To &H6F
        With MidSwap(CurSong)
            TempStr = GetSongName(CurSong)
            If .Changed Then
                TempStr = TempStr & "*"
            End If
            SongList.List(CurSong) = TempStr
        End With
    Next CurSong

End Sub

Private Function GetSongName(ByVal SongID As Byte) As String

    Dim ModeNum As Byte
    Dim SongNum As Byte
    Dim ModeName As String
    
    ModeNum = Int(SongID / &H38)
    SongNum = SongID Mod &H38
    ModeName = Chr$(&H46 + ModeNum) & "M"
    GetSongName = ModeName & " " & Format$(SongNum, "00") & " " & _
                IIf(NameMode, SONG_NAME_LONG(SongNum), SONG_NAME(SongNum))

End Function

Private Function Song2FileName(ByVal SongName As String) As String

    Dim TempArr() As Byte
    Dim CurChr As Integer
    
    TempArr() = StrConv(SongName, vbFromUnicode)
    For CurChr = &H0 To Len(SongName) - 1
        Select Case TempArr(CurChr)
        Case &H30 To &H39, &H41 To &H5A, &H61 To &H7A
            ' OK - no action needed
        Case Else
            TempArr(CurChr) = &H5F  ' replace with '_'
        End Select
    Next CurChr
    
    Song2FileName = StrConv(TempArr(), vbUnicode)

End Function

Private Sub MenuFileEntry_Click(Index As Integer)

    Select Case Index
    Case 0
        Call OpenDLLFile
    Case 1
        Call SaveDLLFile
    Case 3
        Unload Me
    End Select

End Sub

Private Sub MenuDmpRplEntry_Click(Index As Integer)

    Select Case Index
    Case 0
        Call DumpAllToFiles(False)
    Case 1
        Call DumpAllToFiles(True)
    Case 2
        Call ReplaceAllFiles(False)
    Case 3
        Call ReplaceAllFiles(True)
    Case 5
        Call DumpRplSysEx(False)
    Case 6
        Call DumpRplSysEx(True)
    End Select

End Sub

Private Sub MenuExtrasEntry_Click(Index As Integer)

    Select Case Index
    Case 0
        Call ConvertFile(False)
    Case 1
        Call ConvertFile(True)
    Case 2
        Call BinCompression(False)
    Case 3
        Call BinCompression(True)
    End Select

End Sub

Private Sub MenuOptExEntry_Click(Index As Integer)

    Select Case Index
    Case 0
        MenuOptExEntry(Index).Checked = Not MenuOptExEntry(Index).Checked
        CnvOpts.LoopCtrl = MenuOptExEntry(Index).Checked
    Case 1
        LoopSetForm.Show vbModal, Me
        MenuOptExEntry(1).Caption = "&Loops: " & CStr(CnvOpts.LoopCnt) & " ..."
    End Select

End Sub

Private Sub MenuOptImEntry_Click(Index As Integer)

    If Index = 2 Then Exit Sub
    
    MenuOptImEntry(Index).Checked = Not MenuOptImEntry(Index).Checked
    If Index = 1 Then
        MenuOptImEntry(2).Enabled = MenuOptImEntry(1).Checked
    End If
    Select Case Index
    Case 0
        CnvOpts.FixLoops = MenuOptImEntry(0).Checked
    Case 1
        CnvOpts.StdzMidis = MenuOptImEntry(1).Checked
    End Select

End Sub

Private Sub MenuStdOptEntry_Click(Index As Integer)

    If Index <> 2 Then
        MenuStdOptEntry(Index).Checked = Not MenuStdOptEntry(Index).Checked
    End If
    
    Select Case Index
    Case 0
        StdzOpts.XGDrum = MenuStdOptEntry(0).Checked
    Case 1
        StdzOpts.NoUncmnCtrls = MenuStdOptEntry(1).Checked
    Case 2
        StdzCtrlForm.Show vbModal, Me
    Case 3
        StdzOpts.DrumBnkSel = MenuStdOptEntry(3).Checked
    End Select

End Sub

Private Sub SongList_Click()

    If SongList.ListIndex = -1 Then Exit Sub
    
    DumpRplButton(2).Enabled = MidSwap(SongList.ListIndex).Changed

End Sub

Private Sub DumpRplButton_Click(Index As Integer)

    Select Case Index
    Case 0
        Call DumpSingleFile(FormatOption(1).Value)
    Case 1
        Call ReplaceSingleFile(FormatOption(1).Value)
    Case 2
        Call ResetFile
    End Select

End Sub

Private Sub OpenDLLFile()

    Const MZ_SIG As String = "MZ"
    Const CMP_SIG As String = "CMP"
    Dim FileName As String
    Dim TempStr As String
    Dim CurSong As Byte
    
    If Not DiscardQuestion(vbNewLine & _
        "Do you really want to lose all work you've done?") Then Exit Sub
    
    FileName = OpenDialog("S&K PC Midi DLL (MIDIOUT.DLL)|MIDIOUT*.DLL|" & _
                            "All DLL Files (*.dll)|*.dll")
    If FileName = "" Then Exit Sub
    
    Open FileName For Binary Access Read As #1
        TempStr = String$(Len(MZ_SIG), &H0)
        Get #1, 1 + &H0, TempStr
        If TempStr <> MZ_SIG Then
            Close #1
            MsgBox "Not a Win32 DLL!", vbCritical
            Exit Sub
        End If
        
        TempStr = String$(Len(CMP_SIG), &H0)
        Get #1, 1 + &H12C40, TempStr
        If TempStr <> CMP_SIG Then
            Close #1
            MsgBox "Wrong DLL!", vbCritical
            Exit Sub
        End If
        
        StatusLabel.Caption = "Loading ..."
        StatusLabel.Refresh
        DLLSize = LOF(1)
        ReDim DLLData(&H0 To DLLSize - 1)
        Get #1, 1, DLLData()
    Close #1
    
    DLLName = FileName
    
    MidCount = &H70
    ReDim MidTOC(&H0 To MidCount - 1)
    Call CopyMemory(MidTOC(&H0), DLLData(&H16828), &H10& * MidCount)
    
    For CurSong = &H0 To MidCount - 1
        With MidSwap(CurSong)
            .DataPos = MidTOC(CurSong).DataPos - &H5600
            .DataLen = MidTOC(CurSong).DataLen
            ReDim .Data(&H0 To .DataLen - 1)
            Call CopyMemory(.Data(&H0), DLLData(.DataPos), .DataLen)
            .Changed = False
        End With
    Next CurSong
    StatusLabel.Caption = "DLL loaded."
    
    MenuFileEntry(1).Enabled = True
    MenuDmpRpl.Enabled = True
    SongList.Enabled = True
    For CurSong = 0 To 1
        DumpRplButton(CurSong).Enabled = True
    Next CurSong
    DumpRplButton(2).Enabled = False
    FormatLabel.Enabled = True
    For CurSong = 0 To 1
        FormatOption(CurSong).Enabled = True
    Next CurSong

End Sub

Private Sub SaveDLLFile()

    Dim FileName As String
    Dim EndDataSize As Long
    Dim EndData() As Byte
    Dim ResDataSt As Long
    Dim ResDataEnd As Long
    Dim EndDataPos As Long
    Dim CurPos As Long
    Dim CurSong As Byte
    Dim TempLng As Long
    Dim SizeRound As Long
    Dim MsgRes As VbMsgBoxResult
    
    FileName = SaveDialog("DLL Files (*.dll)|*.dll", False, , DLLName)
    If FileName = "" Then Exit Sub
    
    If ClearFileContent(FileName) Then Exit Sub
    
    DLLName = FileName
    
    Call CopyMemory(CurPos, DLLData(&H254), &H4)
    EndDataSize = DLLSize - CurPos
    ReDim EndData(&H0 To EndDataSize - 1)
    Call CopyMemory(EndData(&H0), DLLData(CurPos), EndDataSize)
    
    ' Recalc MIDI Data Positions
    ResDataSt = MidSwap(&H0).DataPos
    CurPos = ResDataSt
    For CurSong = &H0 To MidCount - 1
        With MidSwap(CurSong)
            ' round to full DWORDs (4 Byte)
            ' (Note: This is NOT done after adding the Data Length.)
            CurPos = (CurPos + &H3) And &HFFFFFFFC
            
            .DataPos = CurPos
            MidTOC(CurSong).DataPos = .DataPos + &H5600
            MidTOC(CurSong).DataLen = .DataLen
            CurPos = CurPos + .DataLen
        End With
    Next CurSong
    ' If I don't round the data size here, SKC may refuse to accept the DLL
    CurPos = CurPos + ((&H998 - CurPos) And &H7FF)
    ResDataEnd = CurPos
    
    ' Round up to whole 512-byte-blocks
    EndDataPos = (ResDataEnd + &H1FF) And &HFFFFFE00
    DLLSize = EndDataPos + EndDataSize
    ReDim Preserve DLLData(&H0 To DLLSize - 1)
    
    ' at first, fill all space MIDI data with zeroes
    ' (this way I don't need to care about padding bytes)
    TempLng = EndDataPos - ResDataSt
    Call FillMemory(DLLData(ResDataSt), TempLng, &H0)
    
    ' Copy data that follows the MIDIs
    Call CopyMemory(DLLData(EndDataPos), EndData(&H0), EndDataSize)
    Erase EndData()
    
    ' Copy MIDI-Rescource TOC
    Call CopyMemory(DLLData(&H16828), MidTOC(&H0), &H10& * MidCount)
    ' Copy MIDIs
    For CurSong = &H0 To MidCount - 1
        With MidSwap(CurSong)
            Call CopyMemory(DLLData(.DataPos), .Data(&H0), .DataLen)
            .Changed = False
        End With
    Next CurSong
    
    ' Write Rescource-Length
    TempLng = ResDataEnd - &H15A00
    Call CopyMemory(DLLData(&H10C), TempLng, &H4)
    Call CopyMemory(DLLData(&H220), TempLng, &H4)
    
    ' Write unknown values that need 4-KB-rounding
    SizeRound = (ResDataEnd + &HFFF) And &HFFFFF000
    TempLng = &H7000 + SizeRound
    Call CopyMemory(DLLData(&HD0), TempLng, &H4)
    TempLng = &H5000 + SizeRound
    Call CopyMemory(DLLData(&H120), TempLng, &H4)
    Call CopyMemory(DLLData(&H24C), TempLng, &H4)
    
    ' Write other pointers (512-byte-rounding)
    TempLng = ResDataEnd - &H15A00
    SizeRound = (TempLng + &H1FF) And &HFFFFFE00
    Call CopyMemory(DLLData(&H228), SizeRound, &H4)
    Call CopyMemory(DLLData(&H254), EndDataPos, &H4)
    TempLng = EndDataPos + &H1600
    Call CopyMemory(DLLData(&H11818), TempLng, &H4)
    TempLng = EndDataPos + &H1710
    Call CopyMemory(DLLData(&H11834), TempLng, &H4)
    TempLng = EndDataPos + &H1B10
    Call CopyMemory(DLLData(&H11850), TempLng, &H4)
    
    ' Offsets to correct (compared: original DLL / nineko's modified DLL):
    '   00A0    0E3200/159C00: FileSize - F400
    '   00D0 !  0F8000/16F000: Diff 7 7000
    '   010C !  0DAF98/1518D9: Diff 7 6941 (Data End - 1 5A00, Rescource Length)
    '   0120 !  0F6000/16D000: Diff 7 7000
    '   0220 !  0DAF98/1518D9 (same as 010C)
    '   0228    0DB000/151A00: Diff 7 6A00
    '   024C    0F6000/16D000 (same as 0120)
    '   0254    0F0A00/167400: Diff 7 6A00
    '  11818    0F2000/168A00: Diff 7 6A00
    '  11834    0F2110/168B10: Diff 7 6A00
    '  11850    0F2510/168F10: Diff 7 6A00
    
    ' 0D B000/15 1A00 - Data Length
    ' 0F 0998/16 72D9 - Data End    Diff: 76941
    ' 0F 0A00/16 7400 - End offset  Diff: 76A00
    ' 0F 2600/16 9000 - File Size   Diff: 76A00
    
    'If ClearFileContent(FileName) Then Exit Sub    ' already done
    Open FileName For Binary Access Write As #2
        Put #2, 1, DLLData()
    Close #2
    StatusLabel.Caption = "DLL saved."
    
    Call RewriteSongList

End Sub

Private Sub DumpAllToFiles(ByVal ToMid As Boolean)

    Dim Path As String
    Dim CurSong As Byte
    Dim FileName As String
    Dim BinSize As Long
    Dim BinData() As Byte
    Dim MidSize As Long
    Dim MidData() As Byte
    
    Path = SaveDialog("All files (*.*)|*", True, "Choose a directory ...")
    If Path = "" Then Exit Sub
    
    StatusLabel.Caption = "Dumping all files ..."
    StatusLabel.Refresh
    Path = Left$(Path, InStrRev(Path, "\"))
    
    For CurSong = &H0 To MidCount - 1
        With MidSwap(CurSong)
            FileName = Path & Song2FileName(GetSongName(CurSong))
            
            BinSize = DecompressData(.DataLen, .Data(), BinData())
            If BinSize = &H0 Then
                MsgBox "Error decompressing data!" & vbNewLine & _
                        "Song ID: " & Format$(CurSong, "00"), vbCritical
                Exit Sub
            End If
            
            If Not ToMid Then
                If ClearFileContent(FileName & ".bin") Then Exit Sub
                Open FileName & ".bin" For Binary Access Write As #2
                    Put #2, 1, BinData()
                Close #2
            Else
                MidSize = BIN2MID(BinSize, BinData(), MidData())
                If MidSize = &H0 Then
                    MsgBox "Error converting BIN -> MID!" & vbNewLine & _
                            "Song ID: " & Format$(CurSong, "00"), vbCritical
                    Exit Sub
                End If
                If ClearFileContent(FileName & ".mid") Then Exit Sub
                Open FileName & ".mid" For Binary Access Write As #2
                    Put #2, 1, MidData()
                Close #2
            End If
        End With
    Next CurSong
    
    StatusLabel.Caption = "Done."

End Sub

Private Sub ReplaceAllFiles(ByVal LoadMid As Boolean)

    Dim Path As String
    Dim CurSong As Byte
    Dim FileName As String
    Dim BinSize As Long
    Dim BinData() As Byte
    Dim MidSize As Long
    Dim MidData() As Byte
    
    Path = OpenDialog(IIf(LoadMid, FILTER_MID, FILTER_BIN), _
                        "Choose a directory ...")
    If Path = "" Then Exit Sub
    
    StatusLabel.Caption = "Checking for availablility ..."
    StatusLabel.Refresh
    Path = Left$(Path, InStrRev(Path, "\"))
    
    For CurSong = &H0 To MidCount - 1
        With MidSwap(CurSong)
            FileName = Song2FileName(GetSongName(CurSong)) & _
                        IIf(LoadMid, ".mid", ".bin")
            
            If Dir(Path & FileName, vbHidden) = "" Then
                MsgBox "File " & FileName & " not available!", vbCritical
                StatusLabel.Caption = ""
                Exit Sub
            End If
        End With
    Next CurSong
    
    StatusLabel.Caption = "Replacing all files ..."
    StatusLabel.Refresh
    
    For CurSong = &H0 To MidCount - 1
        With MidSwap(CurSong)
            FileName = Song2FileName(GetSongName(CurSong))
            
            If Not LoadMid Then
                Open Path & FileName & ".bin" For Binary Access Read As #1
                    BinSize = LOF(1)
                    ReDim BinData(&H0 To BinSize - 1)
                    Get #1, 1, BinData()
                Close #1
            Else
                Open Path & FileName & ".mid" For Binary Access Read As #1
                    MidSize = LOF(1)
                    ReDim MidData(&H0 To MidSize - 1)
                    Get #1, 1, MidData()
                Close #1
                BinSize = MID2BIN(MidSize, MidData(), BinData())
                If BinSize = &H0 Then
                    MsgBox "Error converting MID -> BIN!" & vbNewLine & _
                            "Song ID: " & Format$(CurSong, "00"), vbCritical
                    Exit Sub
                End If
            End If
            
            .DataLen = CompressData(BinSize, BinData(), .Data())
            If .DataLen = &H0 Then
                MsgBox "Error compressing data!" & vbNewLine & _
                        "Song ID: " & Format$(CurSong, "00"), vbCritical
                Exit Sub
            End If
            .Changed = True
        End With
    Next CurSong
    
    StatusLabel.Caption = "Done."
    Call RewriteSongList

End Sub

Private Sub DumpRplSysEx(ByVal Mode As Boolean)

    Dim FileName As String
    Dim SyXPos As Long
    Dim SyxP2 As Long
    Dim SyXSize As Long
    Dim SyXData() As Byte
    Dim TempByt As Byte
    Dim CurPos As Long
    Dim InSyX As Boolean
    
    Select Case Mode
    Case False  ' Dump
        FileName = SaveDialog(FILTER_SYX, False, , "Init.syx")
        If FileName = "" Then Exit Sub
        
        CurPos = &H12C48
        InSyX = False
        ReDim SyXData(&H0 To &H16)
        SyxP2 = &H0
        For SyXPos = &H0 To &H16
            If Not InSyX Then
                If DLLData(CurPos + SyXPos) = &H0 Then _
                    Exit For
                InSyX = True
                SyXData(SyxP2) = DLLData(CurPos + SyXPos)
                SyxP2 = SyxP2 + &H1
            Else
                TempByt = DLLData(CurPos + SyXPos)
                Call CopyMemory(SyXData(SyxP2), _
                                DLLData(CurPos + SyXPos + &H1), TempByt)
                SyxP2 = SyxP2 + TempByt
                SyXPos = SyXPos + TempByt
                InSyX = False
            End If
        Next SyXPos
        SyXSize = SyxP2
        If SyXSize = &H0 Then SyXSize = &H1
        ReDim Preserve SyXData(&H0 To SyXSize - 1)
        
        If ClearFileContent(FileName) Then Exit Sub
        Open FileName For Binary Access Write As #2
            Put #2, 1, SyXData()
        Close #2
        
        StatusLabel.Caption = "SysEx-Data dumped."
    Case True   ' Replace
        FileName = OpenDialog(FILTER_SYX)
        If FileName = "" Then Exit Sub
        
        Open FileName For Binary Access Read As #1
            SyXSize = LOF(1)
            If SyXSize >= &H16 Then
                Close #1
                MsgBox "You can't insert more than 21 bytes!", vbCritical
                Exit Sub
            End If
            If SyXSize > &H0 Then
                ReDim SyXData(&H0 To SyXSize - 1)
                Get #1, 1, SyXData()
            Else
                ReDim SyXData(&H0 To &H0)
            End If
        Close #1
        
        CurPos = &H12C48
        Call FillMemory(DLLData(CurPos), &H18, &H0)
        
        InSyX = False
        SyxP2 = &H0
        For SyXPos = &H0 To SyXSize - 1
            If Not InSyX Then
                If SyXData(SyXPos) = &H0 Then _
                    Exit For
                InSyX = True
                DLLData(CurPos + SyxP2) = SyXData(SyXPos)
                SyxP2 = SyxP2 + &H1
                TempByt = SyxP2
                SyxP2 = SyxP2 + &H1
            Else
                DLLData(CurPos + SyxP2) = SyXData(SyXPos)
                If SyXData(SyXPos) = &HF7 Then
                    DLLData(CurPos + TempByt) = SyxP2 - TempByt
                    InSyX = False
                End If
                SyxP2 = SyxP2 + &H1
            End If
        Next SyXPos
        DLLData(CurPos + SyxP2) = &H0
        
        StatusLabel.Caption = "SysEx-Data replaced."
    End Select

End Sub

Private Sub ConvertFolder(ByVal Path As String)

    Dim FileCount As Long
    Dim Files() As String
    Dim FileName As String
    Dim CurFile As Long
    
    FileName = Dir(Path & "*.mid")
    Do Until FileName = ""
        ReDim Preserve Files(&H0 To FileCount)
        Files(FileCount) = Path & FileName
        FileCount = FileCount + &H1
        
        FileName = Dir()
    Loop
    
    For CurFile = &H0 To FileCount - 1
        Call ConvertFile(True, Files(CurFile))
    Next CurFile

End Sub

Private Sub ConvertFile(ByVal Mode As Boolean, Optional FileName As String)

    Dim BinName As String
    Dim MidName As String
    Dim BinSize As Long
    Dim BinData() As Byte
    Dim MidSize As Long
    Dim MidData() As Byte
    
    Select Case Mode
    Case False  ' BIN -> MID
        If FileName = "" Then
            BinName = OpenDialog(FILTER_BIN)
        Else
            BinName = FileName
        End If
        If BinName = "" Then Exit Sub
        
        Open BinName For Binary Access Read As #1
            BinSize = LOF(1)
            ReDim BinData(&H0 To BinSize - 1)
            Get #1, 1, BinData()
        Close #1
        
        MidSize = BIN2MID(BinSize, BinData(), MidData())
        If MidSize = &H0 Then
            MsgBox "Error converting BIN -> MID!", vbCritical
            Exit Sub
        End If
        
        MidName = RemoveExtention(BinName)
        MidName = SaveDialog(FILTER_MID, False, , MidName)
        If MidName = "" Then Exit Sub
        
        If ClearFileContent(MidName) Then Exit Sub
        Open MidName For Binary Access Write As #2
            Put #2, 1, MidData()
        Close #2
    Case True   ' MID -> BIN
        If FileName = "" Then
            MidName = OpenDialog(FILTER_MID)
        Else
            MidName = FileName
        End If
        If MidName = "" Then Exit Sub
        
        Open MidName For Binary Access Read As #1
            MidSize = LOF(1)
            ReDim MidData(&H0 To MidSize - 1)
            Get #1, 1, MidData()
        Close #1
        
        BinSize = MID2BIN(MidSize, MidData(), BinData())
        If BinSize = &H0 Then
            MsgBox "Error converting MID -> BIN!", vbCritical
            Exit Sub
        End If
        
        BinName = RemoveExtention(MidName)
        BinName = SaveDialog(FILTER_BIN, False, , BinName)
        If BinName = "" Then Exit Sub
        
        If ClearFileContent(BinName) Then Exit Sub
        Open BinName For Binary Access Write As #2
            Put #2, 1, BinData()
        Close #2
    End Select
    
    StatusLabel.Caption = "File converted."

End Sub

Private Sub BinCompression(ByVal Mode As Boolean)

    Dim CmpName As String
    Dim BinName As String
    Dim CmpSize As Long
    Dim CmpData() As Byte
    Dim BinSize As Long
    Dim BinData() As Byte
    
    Select Case Mode
    Case False  ' Decompress
        CmpName = OpenDialog(FILTER_CMP)
        If CmpName = "" Then Exit Sub
        
        Open CmpName For Binary Access Read As #1
            CmpSize = LOF(1)
            ReDim CmpData(&H0 To CmpSize - 1)
            Get #1, 1, CmpData()
        Close #1
        
        BinSize = DecompressData(CmpSize, CmpData(), BinData())
        If BinSize = &H0 Then
            MsgBox "Error decompressing data!", vbCritical
            Exit Sub
        End If
        
        BinName = RemoveExtention(CmpName)
        BinName = SaveDialog(FILTER_BIN, False, , BinName)
        If BinName = "" Then Exit Sub
        
        If ClearFileContent(BinName) Then Exit Sub
        Open BinName For Binary Access Write As #2
            Put #2, 1, BinData()
        Close #2
        
        StatusLabel.Caption = "File compressed."
    Case True   ' Compress
        BinName = OpenDialog(FILTER_BIN)
        If BinName = "" Then Exit Sub
        
        Open BinName For Binary Access Read As #1
            BinSize = LOF(1)
            ReDim BinData(&H0 To BinSize - 1)
            Get #1, 1, BinData()
        Close #1
        
        CmpSize = CompressData(BinSize, BinData(), CmpData())
        If BinSize = &H0 Then
            MsgBox "Error compressing data!", vbCritical
            Exit Sub
        End If
        
        CmpName = RemoveExtention(BinName)
        CmpName = SaveDialog(FILTER_CMP, False, , CmpName)
        If CmpName = "" Then Exit Sub
        
        If ClearFileContent(CmpName) Then Exit Sub
        Open CmpName For Binary Access Write As #2
            Put #2, 1, CmpData()
        Close #2
        
        StatusLabel.Caption = "File decompressed."
    End Select

End Sub

Private Sub DumpSingleFile(ByVal ToMid As Boolean)

    If SongList.ListIndex = -1 Then Exit Sub
    
    Dim FileName As String
    Dim BinSize As Long
    Dim BinData() As Byte
    Dim MidSize As Long
    Dim MidData() As Byte
    
    FileName = SaveDialog(IIf(ToMid, FILTER_MID, FILTER_BIN), False, , _
                            Song2FileName(GetSongName(SongList.ListIndex)))
    If FileName = "" Then Exit Sub
    
    With MidSwap(SongList.ListIndex)
        BinSize = DecompressData(.DataLen, .Data(), BinData())
        If BinSize = &H0 Then
            MsgBox "Error decompressing data!", vbCritical
            Exit Sub
        End If
        
        If Not ToMid Then
            If ClearFileContent(FileName) Then Exit Sub
            Open FileName For Binary Access Write As #2
                Put #2, 1, BinData()
            Close #2
        Else
            MidSize = BIN2MID(BinSize, BinData(), MidData())
            If MidSize = &H0 Then
                MsgBox "Error converting BIN -> MID!", vbCritical
                Exit Sub
            End If
            If ClearFileContent(FileName) Then Exit Sub
            Open FileName For Binary Access Write As #2
                Put #2, 1, MidData()
            Close #2
        End If
        
        StatusLabel.Caption = "Song dumped."
    End With

End Sub

Private Sub ReplaceSingleFile(ByVal LoadMid As Boolean)

    If SongList.ListIndex = -1 Then Exit Sub
    
    Dim FileName As String
    Dim BinSize As Long
    Dim BinData() As Byte
    Dim MidSize As Long
    Dim MidData() As Byte
    
    FileName = OpenDialog(IIf(LoadMid, FILTER_MID, FILTER_BIN), False)
    If FileName = "" Then Exit Sub
    
    With MidSwap(SongList.ListIndex)
        If Not LoadMid Then
            Open FileName For Binary Access Read As #1
                BinSize = LOF(1)
                ReDim BinData(&H0 To BinSize - 1)
                Get #1, 1, BinData()
            Close #1
        Else
            Open FileName For Binary Access Read As #1
                MidSize = LOF(1)
                ReDim MidData(&H0 To MidSize - 1)
                Get #1, 1, MidData()
            Close #1
            BinSize = MID2BIN(MidSize, MidData(), BinData())
            If BinSize = &H0 Then
                MsgBox "Error converting MID -> BIN!", vbCritical
                Exit Sub
            End If
        End If
        
        .DataLen = CompressData(BinSize, BinData(), .Data())
        If .DataLen = &H0 Then
            MsgBox "Error compressing data!", vbCritical
            Exit Sub
        End If
        .Changed = True
        
        StatusLabel.Caption = "Song replaced."
    End With
    
    Call RewriteSongList
    Call SongList_Click

End Sub

Private Sub ResetFile()

    With MidSwap(SongList.ListIndex)
        ' Reload original DLL data
        .DataPos = MidTOC(SongList.ListIndex).DataPos - &H5600
        .DataLen = MidTOC(SongList.ListIndex).DataLen
        ReDim .Data(&H0 To .DataLen - 1)
        Call CopyMemory(.Data(&H0), DLLData(.DataPos), .DataLen)
        .Changed = False
        
        StatusLabel.Caption = "Original song restored."
    End With
    
    Call RewriteSongList
    Call SongList_Click

End Sub


Private Function OpenDialog(ByVal Filter As String, _
                            Optional ByVal Title As String) As String

    ' Function from gym2mid
    Dim OFLNM As OPENFILENAME
    Dim lReturn As Long
    
    Filter = Replace(Filter, "|", Chr$(&H0))
    With OFLNM
        .lStructSize = Len(OFLNM)
        .hwndOwner = Me.hWnd
        .hInstance = App.hInstance
        .lpstrFilter = Filter
        .nFilterIndex = &H1
        .lpstrFile = String$(&H101, &H0)
        .nMaxFile = Len(.lpstrFile) - 1
        .lpstrFileTitle = .lpstrFile
        .nMaxFileTitle = .nMaxFile
        '.lpstrInitialDir = ""
        'If Title <> "" Then .lpstrTitle = Title
        .Flags = OFN_FILEMUSTEXIST Or OFN_PATHMUSTEXIST
        .lpstrDefExt = Mid$(Filter, InStrRev(Filter, ".") + 1)
        
        lReturn = GetOpenFileName(OFLNM)
        If lReturn <> &H0 Then
            OpenDialog = .lpstrFile
            OpenDialog = Left$(OpenDialog, InStr(1, OpenDialog, Chr$(&H0)) - 1)
        Else
            OpenDialog = ""
        End If
    
    End With

End Function

Private Function SaveDialog(ByVal Filter As String, ByVal PathMode As Boolean, _
                            Optional ByVal Title As String, _
                            Optional ByVal FileName As String) As String

    ' Function from gym2mid
    Dim OFLNM As OPENFILENAME
    Dim lReturn As Long
    
    Filter = Replace(Filter, "|", Chr$(&H0))
    With OFLNM
        .lStructSize = Len(OFLNM)
        .hwndOwner = Me.hWnd
        .hInstance = App.hInstance
        .lpstrFilter = Filter
        .nFilterIndex = &H1
        .lpstrFile = String$(&H101, &H0)
        If PathMode Then
            .lpstrFile = "ignored" & Mid$(.lpstrFile, 8)
        ElseIf FileName <> "" Then
            .lpstrFile = FileName & Mid$(.lpstrFile, Len(FileName) + 1)
        End If
        .nMaxFile = Len(.lpstrFile) - 1
        .lpstrFileTitle = .lpstrFile
        .nMaxFileTitle = .nMaxFile
        '.lpstrInitialDir = ""
        If Title <> "" Then .lpstrTitle = Title
        If Not PathMode Then
            .Flags = OFN_OVERWRITEPROMPT Or OFN_HIDEREADONLY Or _
                    OFN_PATHMUSTEXIST Or OFN_CREATEPROMPT
        Else
            .Flags = OFN_HIDEREADONLY
        End If
        .lpstrDefExt = Mid$(Filter, InStrRev(Filter, Chr$(&H0)) + 2)
        
        lReturn = GetSaveFileName(OFLNM)
        If lReturn <> &H0 Then
            SaveDialog = .lpstrFile
            SaveDialog = Left$(SaveDialog, InStr(1, SaveDialog, Chr$(&H0)) - 1)
        Else
            SaveDialog = ""
        End If
    
    End With

End Function

Private Function RemoveExtention(ByVal FileName As String) As String

    Dim SlashPos As Long
    Dim DotPos As Long
    
    SlashPos = InStrRev(FileName, "\")
    DotPos = InStrRev(FileName, ".")
    If SlashPos >= DotPos Then
        RemoveExtention = FileName
    Else
        RemoveExtention = Left$(FileName, DotPos - 1)
    End If

End Function

Private Function ClearFileContent(ByVal FileName As String) As Boolean

    Dim MsgRes As VbMsgBoxResult
    
    On Error GoTo SaveError
    Open FileName For Output As #2  ' Clear contents of file
    Close #2
    
    ClearFileContent = False
    
    Exit Function

SaveError:

    MsgRes = MsgBox("Error saving file!" & vbNewLine & _
                    "Error " & Format$(Err.Number) & ": " & Err.Description, _
                    vbExclamation Or vbRetryCancel)
    If MsgRes = vbRetry Then Resume
    
    StatusLabel.Caption = "Save cancelled."
    ClearFileContent = True
    
    Exit Function

End Function
