VERSION 5.00
Begin VB.Form LoopSetForm 
   BorderStyle     =   3  'Fester Dialog
   Caption         =   "Set Loops"
   ClientHeight    =   1395
   ClientLeft      =   2760
   ClientTop       =   3750
   ClientWidth     =   3510
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   93
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   234
   ShowInTaskbar   =   0   'False
   Begin VB.VScrollBar LoopScroll 
      Height          =   255
      Left            =   2790
      Max             =   1
      Min             =   -1
      TabIndex        =   2
      Top             =   315
      Width           =   255
   End
   Begin VB.TextBox LoopText 
      Alignment       =   1  'Rechts
      Height          =   285
      Left            =   2040
      MaxLength       =   3
      TabIndex        =   1
      Text            =   "0"
      Top             =   315
      Width           =   735
   End
   Begin VB.CommandButton CancelButton 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   240
      TabIndex        =   3
      Top             =   840
      Width           =   855
   End
   Begin VB.CommandButton OKButton 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   2400
      TabIndex        =   4
      Top             =   840
      Width           =   855
   End
   Begin VB.Label LoopLabel 
      Caption         =   "Export Loops (1-255):"
      Height          =   255
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   1815
   End
End
Attribute VB_Name = "LoopSetForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private LoopCnt As Integer

Private Sub Form_Load()

    LoopCnt = CnvOpts.LoopCnt
    Call LoopText_Refresh

End Sub

Private Sub LoopScroll_Change()

    If LoopScroll.Value = 0 Then Exit Sub
    
    LoopCnt = LoopCnt - LoopScroll.Value
    If LoopCnt <= 0 Then
        LoopCnt = 1
    ElseIf LoopCnt > 255 Then
        LoopCnt = 255
    End If
    
    LoopScroll.Value = 0
    Call LoopText_Refresh
    LoopText.SetFocus

End Sub

Private Sub LoopText_KeyDown(KeyCode As Integer, Shift As Integer)

    If Shift = &H0 Then
        Select Case KeyCode
        Case vbKeyUp
            If LoopCnt < 255 Then
                LoopCnt = LoopCnt + 1
                Call LoopText_Refresh
            End If
            KeyCode = 0
        Case vbKeyDown
            If LoopCnt > 1 Then
                LoopCnt = LoopCnt - 1
                Call LoopText_Refresh
            End If
            KeyCode = 0
        Case vbKeyPageUp
            If LoopCnt < 255 Then
                LoopCnt = LoopCnt + 10
                If LoopCnt > 255 Then LoopCnt = 255
                Call LoopText_Refresh
            End If
            KeyCode = 0
        Case vbKeyPageDown
            If LoopCnt > 1 Then
                LoopCnt = LoopCnt - 10
                If LoopCnt < 1 Then LoopCnt = 1
                Call LoopText_Refresh
            End If
            KeyCode = 0
        End Select
    End If

End Sub

Private Sub LoopText_KeyPress(KeyAscii As Integer)

    If (KeyAscii >= &H20 And KeyAscii < &H30) Or KeyAscii > &H39 Then
        Beep
        KeyAscii = &H0
    End If

End Sub

Private Sub LoopText_LostFocus()

    Dim TempLoop As Long
    
    On Error Resume Next
    TempLoop = 0
    TempLoop = CLng(LoopText)
    
    If TempLoop < 0 Or TempLoop > 255 Then TempLoop = 0
    
    If TempLoop <> 0 Then
        LoopCnt = TempLoop
    End If
    Call LoopText_Refresh

End Sub

Private Sub LoopText_Refresh()

    LoopText.Text = CStr(LoopCnt)
    LoopText.SelStart = 0

End Sub

Private Sub CancelButton_Click()

    Unload Me

End Sub

Private Sub OKButton_Click()

    CnvOpts.LoopCnt = LoopCnt And &HFF
    Unload Me

End Sub
